For example, let the string be the first 10 digits of pi,
3141592653
, and the subsequence be123
. Note that the sequence occurs twice:3141592653 1 2 3 1 2 3
This was an interview question that I couldn’t answer and I can’t think of an efficient algorithm and it’s bugging me. I feel like it should be possible to do with a simple regex, but ones like
1.*2.*3
don’t return every subsequence. My naive implementation in Python (count the 3’s for each 2 after each 1) has been running for an hour and it’s not done.
Answer
This is a classical dynamic programming problem (and not typically solved using regular expressions).
My naive implementation (count the 3’s for each 2 after each 1) has been running for an hour and it’s not done.
That would be an exhaustive search approach which runs in exponential time. (I’m surprised it runs for hours though).
Here’s a suggestion for a dynamic programming solution:
Outline for a recursive solution:
(Apologies for the long description, but each step is really simple so bear with me 😉

If the subsequence is empty a match is found (no digits left to match!) and we return 1

If the input sequence is empty we’ve depleted our digits and can’t possibly find a match thus we return 0

(Neither the sequence nor the subsequence are empty.)

(Assume that “abcdef” denotes the input sequence, and “xyz” denotes the subsequence.)

Set
result
to 0 
Add to the
result
the number of matches for bcdef and xyz (i.e., discard the first input digit and recurse) 
If the first two digits match, i.e., a = x
 Add to the
result
the number of matches for bcdef and yz (i.e., match the first subsequence digit and recurse on the remaining subsequence digits)
 Add to the

Return
result
Example
Here’s an illustration of the recursive calls for input 1221 / 12. (Subsequence in bold font, · represents empty string.)
Dynamic programming
If implemented naively, some (sub)problems are solved multiple times (· / 2 for instance in the illustration above). Dynamic programming avoids such redundant computations by remembering the results from previously solved subproblems (usually in a lookup table).
In this particular case we set up a table with
 [length of sequence + 1] rows, and
 [length of subsequence + 1] columns:
The idea is that we should fill in the number of matches for 221 / 2 in the corresponding row / column. Once done, we should have the final solution in cell 1221 / 12.
We start populating the table with what we know immediately (the “base cases”):
 When no subsequence digits are left, we have 1 complete match:

When no sequence digits are left, we can’t have any matches:
We then proceed by populating the table topdown / lefttoright according to the following rule:

In cell [row][col] write the value found at [row1][col].
Intuitively this means “The number of matches for 221 / 2 includes all the matches for 21 / 2.”

If sequence at row row and subseq at column col start with the same digit, add the value found at [row1][col1] to the value just written to [row][col].
Intuitively this means “The number of matches for 1221 / 12 also includes all the matches for 221 / 12.”
The final result looks as follows:
and the value at the bottom right cell is indeed 2.
In Code
Not in Python, (my apologies).
class SubseqCounter {
String seq, subseq;
int[][] tbl;
public SubseqCounter(String seq, String subseq) {
this.seq = seq;
this.subseq = subseq;
}
public int countMatches() {
tbl = new int[seq.length() + 1][subseq.length() + 1];
for (int row = 0; row < tbl.length; row++)
for (int col = 0; col < tbl[row].length; col++)
tbl[row][col] = countMatchesFor(row, col);
return tbl[seq.length()][subseq.length()];
}
private int countMatchesFor(int seqDigitsLeft, int subseqDigitsLeft) {
if (subseqDigitsLeft == 0)
return 1;
if (seqDigitsLeft == 0)
return 0;
char currSeqDigit = seq.charAt(seq.length()seqDigitsLeft);
char currSubseqDigit = subseq.charAt(subseq.length()subseqDigitsLeft);
int result = 0;
if (currSeqDigit == currSubseqDigit)
result += tbl[seqDigitsLeft  1][subseqDigitsLeft  1];
result += tbl[seqDigitsLeft  1][subseqDigitsLeft];
return result;
}
}
Complexity
A bonus for this “fillinthetable” approach is that it is trivial to figure out complexity. A constant amount of work is done for each cell, and we have lengthofsequence rows and lengthofsubsequence columns. Complexity is therefor O(MN) where M and N denote the lengths of the sequences.
Attribution
Source : Link , Question Author : Jake , Answer Author : aioobe